--- /home/usel/atool    2008-06-08 18:20:09.000000000 +0200
+++ atool       2009-02-23 19:39:57.000000000 +0100
@@ -23,6 +23,14 @@
 # This file uses tab stops with a length of two.
 #

+# XXX: We could use -CLSDA but 5.10.0 has a bug which prevents us from
+# specifying this with shebang.
+if (${^UTF8LOCALE}) {
+  use Encode qw(decode_utf8);
+  binmode( $_, ":encoding(UTF-8)") for \*STDIN, \*STDOUT, \*STDERR;
+  $_ = decode_utf8( $_ ) for @ARGV, values %ENV;
+}
+
 use File::Basename;
 use File::Spec;
 use Getopt::Long;
@@ -1630,7 +1639,7 @@
       $out .= "\\\\";
     } elsif ($ch eq "'") {
       $out .= "\\'";
-    } elsif (!POSIX::isprint($ch)) {
+    } elsif ($ch !~ /[[:print:]]/) {
       $out .= sprintf('\\%03o', ord($ch));
     } else {
       $out .= $ch;
